const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Email_logsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const email_logs = await db.email_logs.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        to_email: data.to_email || null,
        provider_id: data.provider_id || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await email_logs.setUser(data.user || null, {
      transaction,
    });

    await email_logs.setOrganizations(data.organizations || null, {
      transaction,
    });

    return email_logs;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const email_logsData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      to_email: item.to_email || null,
      provider_id: item.provider_id || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const email_logs = await db.email_logs.bulkCreate(email_logsData, {
      transaction,
    });

    // For each item created, replace relation files

    return email_logs;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const email_logs = await db.email_logs.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.to_email !== undefined) updatePayload.to_email = data.to_email;

    if (data.provider_id !== undefined)
      updatePayload.provider_id = data.provider_id;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await email_logs.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await email_logs.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await email_logs.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return email_logs;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const email_logs = await db.email_logs.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of email_logs) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of email_logs) {
        await record.destroy({ transaction });
      }
    });

    return email_logs;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const email_logs = await db.email_logs.findByPk(id, options);

    await email_logs.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await email_logs.destroy({
      transaction,
    });

    return email_logs;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const email_logs = await db.email_logs.findOne({ where }, { transaction });

    if (!email_logs) {
      return email_logs;
    }

    const output = email_logs.get({ plain: true });

    output.user = await email_logs.getUser({
      transaction,
    });

    output.organizations = await email_logs.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.to_email) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('email_logs', 'to_email', filter.to_email),
        };
      }

      if (filter.provider_id) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'email_logs',
            'provider_id',
            filter.provider_id,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.email_logs.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('email_logs', 'to_email', query),
        ],
      };
    }

    const records = await db.email_logs.findAll({
      attributes: ['id', 'to_email'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['to_email', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.to_email,
    }));
  }
};
